package de.hhhammer.prozessor.jsb;

public record JMethod<R extends Type<?>>(JAccessor accessor, JModifier modifier, R returnType, Name methodName,
                                         ExpressionWithArguments<R> expressionWithArguments) implements Representation, ImportRepresentation {
    @Override
    public String representImports() {
        return expressionWithArguments.representImports();
    }

    @Override
    public String represent() {
        return accessor.represent() + " " + modifier.represent() + " " + returnType.represent() + " " + methodName.represent() + "(" + expressionWithArguments.representArguments() + ")" + " " + "{" + "\n" +
                "\t" + expressionWithArguments.representExpression() + "\n" +
                "}" + "\n";
    }
}
